#!/bin/bash

# uninstall logic for DH Backup STD 6.19.0.0
# The root privilege is required to uninstall the application

###############################################################################
#             S H U T - D O W N                 S E R V I C E S               #
###############################################################################

# Shutdown Scheduler
if [ -e "/Applications/DH Backup STD/ipc/Scheduler/running" ]; then
    echo "Shutdown Scheduler for DH Backup STD"
    touch "/Applications/DH Backup STD/ipc/Scheduler/stop"
    echo "Wait 5 seconds before Scheduler exits"
    sleep 5
fi

# Shutdown AutoUpdateAgent
if [ -e "/Applications/DH Backup STD/aua/bin" ]; then
    echo "Shutdown AutoUpdateAgent for DH Backup STD"
    sh "/Applications/DH Backup STD/aua/bin/shutdown.sh"
    echo "Wait 5 seconds before AutoUpdateAgent exits"
    sleep 5
fi

###############################################################################
#        T A S K K I L L       A L L      J A V A       P R O C E S S         #
###############################################################################

# Kill all running process
sh "/Applications/DH Backup STD/bin/taskkill" "/Applications/DH Backup STD/BackupManager.app"
sh "/Applications/DH Backup STD/bin/taskkill" "/Applications/DH Backup STD/bin/BackupManager.app"
sh "/Applications/DH Backup STD/bin/taskkill" "/Applications/DH Backup STD/jvm/bin/java"
sh "/Applications/DH Backup STD/bin/taskkill" "/Applications/DH Backup STD/aua/jvm/bin/java"

###############################################################################
#                 R E M O V E                   S E R V I C E S               #
###############################################################################

# Remove Scheduler
if [ -e "/Library/StartupItems/DHBackupSTD" ]; then
    echo "Remove Scheduler for DH Backup STD from service"
    rm -rf "/Library/StartupItems/DHBackupSTD"
fi

# Remove AutoUpdateAgent
if [ -e "/Library/StartupItems/DHBackupSTD-AutoUpdate" ]; then
    echo "Remove AutoUpdateAgent for DH Backup STD from service"
    rm -rf "/Library/StartupItems/DHBackupSTD-AutoUpdate"
fi

###############################################################################
#      R E M O V E        U S E R         D E S K T O P      L I N K          #
###############################################################################

# Remove Desktop Symbolic Link
find /Users -name Desktop -type d -maxdepth 3 -mindepth 2 | while read DESKTOP_PATH;
do
    if [ -e "${DESKTOP_PATH}/DHBackupSTD" ]; then
        echo "Remove Desktop Link DHBackupSTD from path ${DESKTOP_PATH}"
        rm -f "${DESKTOP_PATH}/DHBackupSTD"
        echo "Removed DH Backup STD Desktop Link"
    fi

    if [ -e "${DESKTOP_PATH}/DH Backup STD" ]; then
        echo "Remove Desktop Link DH Backup STD from path ${DESKTOP_PATH}"
        rm -f "${DESKTOP_PATH}/DH Backup STD"
        echo "Removed DH Backup STD Desktop Link"
    fi
done

###############################################################################
#        R E M O V E           A P P L I C A T I O N           H O M E        #
###############################################################################

# Remove DH Backup STD
cd /
if [ -e "/Applications/DH Backup STD" ]; then
    echo "Remove DH Backup STD from Your Mac OS X"
    rm -rf "/Applications/DH Backup STD"
fi

###############################################################################
#        R E M O V E             M A C     O S        R E C E I P T S         #
###############################################################################

# Remove Mac OS X Receipts
if [ -e "/Library/Receipts/acb.pkg" ]; then
    echo "Remove Mac OS X Receipt for acb.pkg (Path: /Library/Receipts/acb.pkg)"
    rm -rf "/Library/Receipts/acb.pkg"
fi
